/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.datatypes.CBitField;
import com.ibm.etools.c.datatypes.CIntegral;
import com.ibm.etools.c.datatypes.DatatypesPackage;
import com.ibm.etools.c.impl.CDatatypeImpl;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>CBit Field</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.datatypes.impl.CBitFieldImpl#getSize <em>Size</em>}
 * </li>
 * <li>
 * {@link com.ibm.etools.c.datatypes.impl.CBitFieldImpl#getBaseType <em>Base Type</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CBitFieldImpl extends CDatatypeImpl implements CBitField {
    /**
     * The default value of the '{@link #getSize() <em>Size</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSize()
     * @generated @ordered
     */
    protected static final Integer SIZE_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getSize() <em>Size</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSize()
     * @generated @ordered
     */
    protected Integer size = SIZE_EDEFAULT;

    /**
     * The cached value of the '{@link #getBaseType() <em>Base Type</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getBaseType()
     * @generated @ordered
     */
    protected CIntegral baseType = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CBitFieldImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return DatatypesPackage.eINSTANCE.getCBitField();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Integer getSize() {
        return size;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSize(Integer newSize) {
        Integer oldSize = size;
        size = newSize;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, DatatypesPackage.CBIT_FIELD__SIZE, oldSize, size));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CIntegral getBaseType() {
        if (baseType != null && baseType.eIsProxy()) {
            CIntegral oldBaseType = baseType;
            baseType = (CIntegral) eResolveProxy((InternalEObject) baseType);
            if (baseType != oldBaseType) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, DatatypesPackage.CBIT_FIELD__BASE_TYPE, oldBaseType, baseType));
            }
        }
        return baseType;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CIntegral basicGetBaseType() {
        return baseType;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBaseType(CIntegral newBaseType) {
        CIntegral oldBaseType = baseType;
        baseType = newBaseType;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, DatatypesPackage.CBIT_FIELD__BASE_TYPE, oldBaseType, baseType));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case DatatypesPackage.CBIT_FIELD__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicAdd(otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case DatatypesPackage.CBIT_FIELD__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicRemove(otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CBIT_FIELD__NAME:
            return getName();
        case DatatypesPackage.CBIT_FIELD__TD_LANG_TYPED_ELEMENT:
            return getTdLangTypedElement();
        case DatatypesPackage.CBIT_FIELD__SIZE:
            return getSize();
        case DatatypesPackage.CBIT_FIELD__BASE_TYPE:
            if (resolve)
                return getBaseType();
            return basicGetBaseType();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CBIT_FIELD__NAME:
            setName((String) newValue);
            return;
        case DatatypesPackage.CBIT_FIELD__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            getTdLangTypedElement().addAll((Collection) newValue);
            return;
        case DatatypesPackage.CBIT_FIELD__SIZE:
            setSize((Integer) newValue);
            return;
        case DatatypesPackage.CBIT_FIELD__BASE_TYPE:
            setBaseType((CIntegral) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CBIT_FIELD__NAME:
            unsetName();
            return;
        case DatatypesPackage.CBIT_FIELD__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            return;
        case DatatypesPackage.CBIT_FIELD__SIZE:
            setSize(SIZE_EDEFAULT);
            return;
        case DatatypesPackage.CBIT_FIELD__BASE_TYPE:
            setBaseType((CIntegral) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case DatatypesPackage.CBIT_FIELD__NAME:
            return isSetName();
        case DatatypesPackage.CBIT_FIELD__TD_LANG_TYPED_ELEMENT:
            return tdLangTypedElement != null && !tdLangTypedElement.isEmpty();
        case DatatypesPackage.CBIT_FIELD__SIZE:
            return SIZE_EDEFAULT == null ? size != null : !SIZE_EDEFAULT.equals(size);
        case DatatypesPackage.CBIT_FIELD__BASE_TYPE:
            return baseType != null;
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (size: ");
        result.append(size);
        result.append(')');
        return result.toString();
    }

} //CBitFieldImpl
