/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CTypedElement;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Derived</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link com.ibm.etools.c.impl.CDerivedImpl#getDerives <em>Derives</em>}
 * </li>
 * <li>
 * {@link com.ibm.etools.c.impl.CDerivedImpl#getContainer <em>Container</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class CDerivedImpl extends CClassifierImpl implements CDerived {
    /**
     * The cached value of the '{@link #getDerives() <em>Derives</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDerives()
     * @generated @ordered
     */
    protected CDerivableType derives = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CDerivedImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCDerived();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CDerivableType getDerives() {
        if (derives != null && derives.eIsProxy()) {
            CDerivableType oldDerives = derives;
            derives = (CDerivableType) eResolveProxy((InternalEObject) derives);
            if (derives != oldDerives) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, CPackage.CDERIVED__DERIVES, oldDerives, derives));
            }
        }
        return derives;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CDerivableType basicGetDerives() {
        return derives;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setDerives(CDerivableType newDerives) {
        CDerivableType oldDerives = derives;
        derives = newDerives;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CDERIVED__DERIVES, oldDerives, derives));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CTypedElement getContainer() {
        if (eContainerFeatureID != CPackage.CDERIVED__CONTAINER)
            return null;
        return (CTypedElement) eContainer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainer(CTypedElement newContainer) {
        if (newContainer != eContainer || (eContainerFeatureID != CPackage.CDERIVED__CONTAINER && newContainer != null)) {
            if (EcoreUtil.isAncestor(this, newContainer))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eContainer != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainer != null)
                msgs = ((InternalEObject) newContainer).eInverseAdd(this, CPackage.CTYPED_ELEMENT__CONTAINS, CTypedElement.class, msgs);
            msgs = eBasicSetContainer((InternalEObject) newContainer, CPackage.CDERIVED__CONTAINER, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CDERIVED__CONTAINER, newContainer, newContainer));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CDERIVED__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicAdd(otherEnd, msgs);
            case CPackage.CDERIVED__CONTAINER:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, CPackage.CDERIVED__CONTAINER, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CDERIVED__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicRemove(otherEnd, msgs);
            case CPackage.CDERIVED__CONTAINER:
                return eBasicSetContainer(null, CPackage.CDERIVED__CONTAINER, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case CPackage.CDERIVED__CONTAINER:
                return ((InternalEObject) eContainer).eInverseRemove(this, CPackage.CTYPED_ELEMENT__CONTAINS, CTypedElement.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CDERIVED__NAME:
            return getName();
        case CPackage.CDERIVED__TD_LANG_TYPED_ELEMENT:
            return getTdLangTypedElement();
        case CPackage.CDERIVED__DERIVES:
            if (resolve)
                return getDerives();
            return basicGetDerives();
        case CPackage.CDERIVED__CONTAINER:
            return getContainer();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CDERIVED__NAME:
            setName((String) newValue);
            return;
        case CPackage.CDERIVED__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            getTdLangTypedElement().addAll((Collection) newValue);
            return;
        case CPackage.CDERIVED__DERIVES:
            setDerives((CDerivableType) newValue);
            return;
        case CPackage.CDERIVED__CONTAINER:
            setContainer((CTypedElement) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CDERIVED__NAME:
            unsetName();
            return;
        case CPackage.CDERIVED__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            return;
        case CPackage.CDERIVED__DERIVES:
            setDerives((CDerivableType) null);
            return;
        case CPackage.CDERIVED__CONTAINER:
            setContainer((CTypedElement) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CDERIVED__NAME:
            return isSetName();
        case CPackage.CDERIVED__TD_LANG_TYPED_ELEMENT:
            return tdLangTypedElement != null && !tdLangTypedElement.isEmpty();
        case CPackage.CDERIVED__DERIVES:
            return derives != null;
        case CPackage.CDERIVED__CONTAINER:
            return getContainer() != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //CDerivedImpl
