/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLSimpleType.java,v 1.2.4.1 2005/10/28 04:37:27 akkina Exp $
 */
package com.ibm.etools.cobol;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Simple Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * COBOLSimpleType is an abstract class that contains attributes shared by all simple types in the COBOL language.  
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOLSimpleType#getUsage <em>Usage</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLSimpleType#getPictureString <em>Picture String</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLSimpleType#getSynchronized <em>Synchronized</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLSimpleType()
 * @model abstract="true"
 * @generated
 */
public interface COBOLSimpleType extends COBOLClassifier {
	/**
	 * Returns the value of the '<em><b>Usage</b></em>' attribute.
	 * The literals are from the enumeration {@link com.ibm.etools.cobol.COBOLUsageValues}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Usage contains the data type as defined in COBOLUsageValues.  
	 * 
	 * Usage defines the format of the data in memory.  If none is specified in the COBOL source, the default is "display".  Note that the popular COMP-3 is equivalent to packed Decimal.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Usage</em>' attribute.
	 * @see com.ibm.etools.cobol.COBOLUsageValues
	 * @see #setUsage(COBOLUsageValues)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLSimpleType_Usage()
	 * @model 
	 * @generated
	 */
	COBOLUsageValues getUsage();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLSimpleType#getUsage <em>Usage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Usage</em>' attribute.
	 * @see com.ibm.etools.cobol.COBOLUsageValues
	 * @see #getUsage()
	 * @generated
	 */
	void setUsage(COBOLUsageValues value);

	/**
	 * Returns the value of the '<em><b>Picture String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This is a canonical form of the picture string specified in the source.  It is *not* necessarily identical to the picture string given in the program!
	 * Procedure to arrive at the canonical form of the picture string:
	 * 1. Expand any parenthesized characters
	 * 2. Construct parenthesized representation for any sequences of identical characters which are longer than 4 characters.
	 * For example:
	 * start with XXX999(3)
	 * after step 1 you get: XXX99999
	 * after step 2 you get: XXX9(5)
	 * This canonical form yields the shortest equivalent picture string.  The canonical form is beneficial for equivalence checking.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Picture String</em>' attribute.
	 * @see #setPictureString(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLSimpleType_PictureString()
	 * @model 
	 * @generated
	 */
	String getPictureString();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLSimpleType#getPictureString <em>Picture String</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Picture String</em>' attribute.
	 * @see #getPictureString()
	 * @generated
	 */
	void setPictureString(String value);

	/**
	 * Returns the value of the '<em><b>Synchronized</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This boolean attribute corresponds to the SYNCHRONIZED or SYNC clause that may optionally be specified for an element.
	 * Note that the COBOL language defines an additional clause -- RIGHT/LEFT -- which may follow the SYNCHRONIZED clause.  However, IBM's implementation of COBOL does support this additional CLAUSE as documentation only -- all elements defined as SYNCHRONIZED are automatically synchronized left.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Synchronized</em>' attribute.
	 * @see #setSynchronized(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLSimpleType_Synchronized()
	 * @model default="false"
	 * @generated
	 */
	Boolean getSynchronized();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLSimpleType#getSynchronized <em>Synchronized</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Synchronized</em>' attribute.
	 * @see #getSynchronized()
	 * @generated
	 */
	void setSynchronized(Boolean value);

} // COBOLSimpleType
