/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLVariableLengthArray.java,v 1.2.4.1 2005/10/28 04:37:27 akkina Exp $
 */
package com.ibm.etools.cobol;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variable Length Array</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A COBOLVariableLengthArray should be instantiated  whenever the source for a COBOLElement has the
 * following syntax:
 * LEVEL ELEMENTNAME1 OCCURS X1 TO X2 TIMES DEPENDING ON ELEMENTNAME2.
 * where X1 and X2 can be any integers 0 and higher and
 * X2 > X1.  ELEMENTNAME2 must be defined before
 * ELEMENTNAME1.
 * COBOLVariableLengthArray has a single required 
 * association that specifies which element this array 
 * depends on.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOLVariableLengthArray#getMinUpper <em>Min Upper</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLVariableLengthArray#getDependingOn <em>Depending On</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLVariableLengthArray()
 * @model 
 * @generated
 */
public interface COBOLVariableLengthArray extends COBOLFixedLengthArray {
	/**
	 * Returns the value of the '<em><b>Min Upper</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * In the case when maxUpper (max upper bound) belongs to VariableArray, maxUpper denotes the absolute upper bound of the array that can be allocated in memory.  The actual maximum is denoted by the value of the element it refers to; which it gets by calling the "dependingOn" association.  
	 * 
	 * minUpper (minimum upper bound) is used to capture the COBOL syntax that reads OCCURS 4 to 7 TIMES DEPENDING ON X1.  In this case, minUpper equals 4 and maxUpper equals 7, and the actual upper bound depends on the value of X1.
	 * 
	 * lower (lower bound) is always 1 (one) in the case of COBOL but is included for consistency with other languages and for clarity.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Min Upper</em>' attribute.
	 * @see #setMinUpper(int)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLVariableLengthArray_MinUpper()
	 * @model 
	 * @generated
	 */
	int getMinUpper();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLVariableLengthArray#getMinUpper <em>Min Upper</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Upper</em>' attribute.
	 * @see #getMinUpper()
	 * @generated
	 */
	void setMinUpper(int value);

	/**
	 * Returns the value of the '<em><b>Depending On</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Depending On</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Depending On</em>' reference.
	 * @see #setDependingOn(COBOLElement)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLVariableLengthArray_DependingOn()
	 * @model required="true"
	 * @generated
	 */
	COBOLElement getDependingOn();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLVariableLengthArray#getDependingOn <em>Depending On</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Depending On</em>' reference.
	 * @see #getDependingOn()
	 * @generated
	 */
	void setDependingOn(COBOLElement value);

} // COBOLVariableLengthArray
