//****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<PART NUMBER - 5724-D15>>
//   (C) Copyright IBM Corp. 2001, 2004 - All Rights Reserved.
//   The source code for this program is not published or otherwise divested
//   of its trade secrets, irrespective of what has been deposited with the
//   U.S. Copyright Office.
//
// ****************************************************************

package com.ibm.etools.marshall;

/**
 * Provides a more performance oriented way for a language based applications
 * to access its underlying storage byte array.
 */

public interface RecordBytes
{
	public static final String copyright = "Licensed Material - Property of IBM <<PART NUMBER - 5724-D15>> (C) Copyright IBM Corp. 2003 - All Rights Reserved. US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$

	/**
	 * Returns an array of bytes that represents the underlying storage
	 * byte array of the bean, or <code>null</code> if no
	 * bytes have been set.
	 */
	public byte[] getBytes();

	/**
	 * Associates an array of bytes with the bean.
	 * @param bytes The array of bytes to be set on the bean.
	 */ 
	public void setBytes (byte[] bytes);


	/**
	 * Returns the content size of the bean's associated byte
	 * array in bytes.  This may not be the actual size of the associated
	 * byte array, as data contained in the byte array could affect the
	 * true size of its contents (for example a COBOL OCCURS DEPENDING ON
	 * clause).
	 * @return The content size of the bean in bytes.
	 */
	public int getSize();
}